SystemOrganization addCategory: #PetitSmalltalk!
SystemOrganization addCategory: 'PetitSmalltalk-Core'!
SystemOrganization addCategory: 'PetitSmalltalk-Tests'!

!PPParser methodsFor: '*petitsmalltalk-operations' stamp: 'JanKurs 11/7/2014 16:51'!
smalltalkToken
	| ws |
	ws := PPSmalltalkWhitespaceParser new.
	^ ((ws, ((PPTokenParser on: self) tokenClass: PPSmalltalkToken; yourself), ws) ==> #second)
		propertyAt: #trimmingToken put: true;
		yourself! !

PPParser subclass: #PPSmalltalkWhitespaceParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Core'!

!PPSmalltalkWhitespaceParser methodsFor: 'initialization' stamp: 'JanKurs 10/26/2014 15:24'!
initialize
	super initialize.! !

!PPSmalltalkWhitespaceParser methodsFor: 'analysis' stamp: 'JanKurs 10/10/2014 16:05'!
isNullable
	^ true! !

!PPSmalltalkWhitespaceParser methodsFor: 'parsing' stamp: 'JanKurs 10/31/2014 11:23'!
name
	^ 'smalltalk_ws'! !

!PPSmalltalkWhitespaceParser methodsFor: 'parsing' stamp: 'JanKurs 10/26/2014 15:23'!
parseOn: aPPContext
	[ [aPPContext atEnd not and: [ aPPContext uncheckedPeek isSeparator ] ]
		whileTrue: [ aPPContext next ].
		
	 aPPContext atEnd not and: [ aPPContext uncheckedPeek = $" ] ] whileTrue: [
		aPPContext next.
		aPPContext upTo: $".
	].! !

PPCompositeParserTest subclass: #PPSmalltalkClassesTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Tests'!

!PPSmalltalkClassesTests commentStamp: 'lr 2/26/2013 01:05' prior: 0!
Evalaute the following code to verify the complete image.!

!PPSmalltalkClassesTests class methodsFor: 'utilities' stamp: 'DamienCassou 3/27/2014 10:42'!
benchmark: aParser
	"self benchmark: PPSmalltalkGrammar new"
	"self benchmark: PPSmalltalkParser new"
	"self benchmark: RBParser"
	
	| sources |
	sources := OrderedCollection new.
	SequenceableCollection withAllSubclassesDo: [ :class |
		class selectorsDo: [ :selector |
			sources add: (class sourceCodeAt: selector) ] ].
	^ self benchmark: aParser sources: sources asArray! !

!PPSmalltalkClassesTests class methodsFor: 'utilities' stamp: 'lr 8/17/2011 23:56'!
benchmark: aParser sources: aCollection
	| count start |
	count := 0.
	start := Time millisecondClockValue.
	[  aCollection do: [ :each | aParser parseMethod: each ].
		count := count + 1.
		(Time millisecondsSince: start) < 10000 ] whileTrue.
	^ (1000 * count * (aCollection detectSum: [ :each | each size ]) 
		/ (Time millisecondsSince: start)) asInteger asString , ' characters/sec'! !

!PPSmalltalkClassesTests class methodsFor: 'accessing' stamp: 'lr 11/29/2010 11:36'!
packageNamesUnderTest
	^ #('PetitSmalltalk')! !

!PPSmalltalkClassesTests class methodsFor: 'utilities' stamp: 'lr 8/11/2011 23:41'!
verifySystem
	Smalltalk globals allClasses
		inject: self new
		into: [ :test :class | test verifyClass: class ]! !

!PPSmalltalkClassesTests methodsFor: 'private' stamp: 'lr 9/27/2009 12:43'!
assert: aBoolean description: aString 
	self 
		assert: aBoolean
		description: aString
		resumable: true! !

!PPSmalltalkClassesTests methodsFor: 'accessing' stamp: 'lr 12/7/2009 09:05'!
parserClass
	^ PPSmalltalkParser! !

!PPSmalltalkClassesTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testCollection
	self verifyClass: Collection.
	self verifyClass: Array.
	self verifyClass: Set.
	self verifyClass: Dictionary.
	self verifyClass: Bag.
	self verifyClass: OrderedCollection.
	self verifyClass: SortedCollection! !

!PPSmalltalkClassesTests methodsFor: 'testing' stamp: 'TestRunner 10/23/2009 18:12'!
testException
	self verifyClass: Exception.
	self verifyClass: Notification.
	self verifyClass: Warning.
	self verifyClass: Error! !

!PPSmalltalkClassesTests methodsFor: 'testing' stamp: 'TestRunner 10/23/2009 18:12'!
testFundamental
	self verifyClass: Object.
	self verifyClass: Boolean.
	self verifyClass: True.
	self verifyClass: False.
	self verifyClass: Character


! !

!PPSmalltalkClassesTests methodsFor: 'testing' stamp: 'TestRunner 10/23/2009 18:10'!
testMagnitude
	self verifyClass: Magnitude.
	self verifyClass: Number.
	self verifyClass: Integer.
	self verifyClass: Float.
	self verifyClass: Fraction! !

!PPSmalltalkClassesTests methodsFor: 'testing-protocol' stamp: 'Nicolasanquetil 5/3/2013 15:17'!
testParseExpression
	result := self parserClass parseExpression: '1 + 2'.
	self assert: result isMessage.
	self assert: result source equals: '1 + 2'.
	result := self parserClass parseExpression: '| a | 1 + a'.
	self assert: result isSequence.
	self assert: result source equals: '| a | 1 + a'.
	result := self parserClass parseExpression: '1 + 2. ^ 3'.
	self assert: result isSequence.
	self assert: result source equals: '1 + 2. ^ 3'.
	result := self parserClass parseExpression: '1 + ' onError: [ :err | true ].
	self assert: result.
	self should: [ self parserClass parseExpression: '1 + ' ] raise: Error! !

!PPSmalltalkClassesTests methodsFor: 'testing-protocol' stamp: 'Nicolasanquetil 5/3/2013 15:01'!
testParseMethod
	result := self parserClass parseMethod: 'do 1 + 2'.
	self assert: result isMethod.
	self assert: result source equals: 'do 1 + 2'.
	result := self parserClass parseMethod: 'do 1 +' onError: [ :err | true ].
	self assert: result.
	self should: [ self parserClass parseMethod: 'do 1 +' ] raise: Error! !

!PPSmalltalkClassesTests methodsFor: 'testing' stamp: 'TestRunner 10/23/2009 18:14'!
testStream
	self verifyClass: Stream.
	self verifyClass: ReadStream.
	self verifyClass: WriteStream! !

!PPSmalltalkClassesTests methodsFor: 'private' stamp: 'lr 5/1/2010 16:28'!
verifyClass: aClass 
	aClass selectors 
		do: [ :selector | self verifyClass: aClass selector: selector ].
	aClass isMeta
		ifFalse: [ self verifyClass: aClass class ]! !

!PPSmalltalkClassesTests methodsFor: 'private' stamp: 'BernardoContreras 3/13/2015 19:30'!
verifyClass: aClass selector: aSelector 
	"Verifies that the method aSelector in aClass parses the same using the standard refactoring parser and the petit smalltalk parser. Also make sure that the position information of all tokens and comments is equal."

	| signature source original other checker |
	signature := aClass name , '>>#' , aSelector.
	source := aClass sourceCodeAt: aSelector.
	source isNil ifTrue: [ ^ self ].
	original := aClass parseTreeFor: aSelector.
	original isNil ifTrue: [ ^ self ].
	other := self parserInstance
		parseMethod: source
		onError: [ :err | self assert: false description: signature ].
	self 
		assert: original = other
		description: 'Code in ' , signature.
	checker := [ :node1 :node2 |
		self 
			assert: node1 sourceInterval = node2 sourceInterval 
			description: 'Source intervals in ' , signature.
		(node1 isArray or: [ node1 isBlock or: [ node1 isPragma ] ]) ifTrue: [
			self
				assert: node1 left = node2 left
				description: 'Source position left in ' , signature.
			self
				assert: node1 right = node2 right
				description: 'Source position right in ' , signature ].
		(node1 isSequence) ifTrue: [
			self
				assert: node1 leftBar = node2 leftBar
				description: 'Source position leftBar in ' , signature.
			self
				assert: node1 rightBar = node2 rightBar
				description: 'Source position rightBar in ' , signature ].
		(node1 isBlock) ifTrue: [
			self
				assert: node1 bar = node2 bar
				description: 'Source position bar in ' , signature ].
		(node1 isReturn) ifTrue: [
			self
				assert: node1 return = node2 return
				description: 'Source position return in ' , signature ].
		(node1 isAssignment) ifTrue: [
			self
				assert: node1 assignment = node2 assignment
				description: 'Source position return in ' , signature ].
		(node1 isCascade) ifTrue: [
			self
				assert: node1 semicolons asArray = node2 semicolons asArray
				description: 'Source position semicolons in ' , signature ].
		(node1 isArray or: [ node1 isSequence ]) ifTrue: [
			self
				assert: node1 periods asArray = node2 periods asArray
				description: 'Source position periods in ' , signature ].
		(node1 isMethod or: [ node1 isMessage or: [ node1 isPragma ] ]) ifTrue: [
			self
				assert: node1 keywordsPositions = node2 keywordsPositions 
				description: 'Source position keywords positions in ' , signature ].
		node1 children with: node2 children do: checker ].
	checker value: original value: other! !

PPCompositeParserTest subclass: #PPSmalltalkGrammarTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Tests'!

!PPSmalltalkGrammarTests class methodsFor: 'accessing' stamp: 'lr 11/29/2010 11:36'!
packageNamesUnderTest
	^ #('PetitSmalltalk')! !

!PPSmalltalkGrammarTests methodsFor: 'accessing' stamp: 'lr 9/27/2009 12:42'!
parserClass
	^ PPSmalltalkGrammar! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testArgumentsBlock1
	self 
		parse: '[ :a | ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testArgumentsBlock2
	self 
		parse: '[ :a :b | ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testArgumentsBlock3
	self 
		parse: '[ :a :b :c | ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 3/1/2010 10:09'!
testArray1
	self 
		parse: '{}'
		rule: #array! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 3/1/2010 10:10'!
testArray2
	self 
		parse: '{self foo}'
		rule: #array! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 3/1/2010 10:10'!
testArray3
	self 
		parse: '{self foo. self bar}'
		rule: #array! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 3/1/2010 10:10'!
testArray4
	self 
		parse: '{self foo. self bar.}'
		rule: #array! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral1
	self 
		parse: '#()'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral10
	self 
		parse: '#((1 2) #(1 2 3))'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral11
	self 
		parse: '#([1 2] #[1 2 3])'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral2
	self 
		parse: '#(1)'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral3
	self 
		parse: '#(1 2)'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral4
	self 
		parse: '#(true false nil)'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral5
	self 
		parse: '#($a)'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral6
	self 
		parse: '#(1.2)'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral7
	self 
		parse: '#(size #at: at:put: #''=='')'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testArrayLiteral8
	self 
		parse: '#(''baz'')'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'TestRunner 10/23/2009 16:52'!
testArrayLiteral9
	self 
		parse: '#((1) 2)'
		rule: #arrayLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testAssignment1
	self 
		parse: '1'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testAssignment2
	self 
		parse: 'a := 1'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testAssignment3
	self 
		parse: 'a := b := 1'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 7/11/2011 11:34'!
testAssignment4
	PPSmalltalkGrammar allowUnderscoreAssignment
		ifTrue: [ self parse: 'a _ 1' rule: #expression ]
		ifFalse: [ self fail: 'a _ 1' rule: #expression ]! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 7/11/2011 11:35'!
testAssignment5
	PPSmalltalkGrammar allowUnderscoreAssignment
		ifTrue: [ self parse: 'a _ b _ 1' rule: #expression ]
		ifFalse: [ self fail: 'a _ b _ 1' rule: #expression ]! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 11/23/2010 14:03'!
testAssignment6
	self 
		parse: 'a := (b := c)'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryExpression1
	self 
		parse: '1 + 2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryExpression2
	self 
		parse: '1 + 2 + 3'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'DamienPollet 8/11/2011 22:20'!
testBinaryExpression3
	self 
		parse: '1 // 2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 8/11/2011 23:28'!
testBinaryExpression4
	self 
		parse: '1 -- 2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 8/11/2011 23:25'!
testBinaryExpression5
	self 
		parse: '1 ==> 2'
		rule: #expression.! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryMethod1
	self 
		parse: '+ a'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryMethod2
	self 
		parse: '+ a | b |'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryMethod3
	self 
		parse: '+ a b'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testBinaryMethod4
	self 
		parse: '+ a | b | c'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 8/11/2011 23:28'!
testBinaryMethod5
	self 
		parse: '-- a'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'JanKurs 10/5/2014 13:51'!
testBlock1
	self 
		parse: '[]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testByteLiteral1
	self 
		parse: '#[]'
		rule: #byteLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testByteLiteral2
	self 
		parse: '#[0]'
		rule: #byteLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testByteLiteral3
	self 
		parse: '#[255]'
		rule: #byteLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testByteLiteral4
	self 
		parse: '#[ 1 2 ]'
		rule: #byteLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testByteLiteral5
	self 
		parse: '#[ 2r1010 8r77 16rFF ]'
		rule: #byteLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testCascadeExpression1
	self 
		parse: '1 abs; negated'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testCascadeExpression2
	self 
		parse: '1 abs negated; raisedTo: 12; negated'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testCascadeExpression3
	self 
		parse: '1 + 2; - 3'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testCharLiteral1
	self 
		parse: '$a'
		rule: #charLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testCharLiteral2
	self 
		parse: '$ '
		rule: #charLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testCharLiteral3
	self 
		parse: '$$'
		rule: #charLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testComment1
	self 
		parse: '1"one"+2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testComment2
	self 
		parse: '1 "one" +2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testComment3
	self 
		parse: '1"one"+"two"2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testComment4
	self 
		parse: '1"one""two"+2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testComment5
	self 
		parse: '1"one"	"two"+2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 8/17/2011 23:57'!
testCompleteness
	"This test asserts that all subclasses override all test methods."
	
	self class allSubclasses do: [ :subclass |
		self class testSelectors do: [ :selector |
			self 
				assert: (selector = #testCompleteness or: [ subclass selectors includes: selector ])
				description: subclass printString , ' does not test ' , selector printString ] ]! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testComplexBlock1
	self 
		parse: '[ :a | | b | c ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testComplexBlock2
	self 
		parse: '[:a||b|c]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordExpression1
	self 
		parse: '1 to: 2'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordExpression2
	self 
		parse: '1 to: 2 by: 3'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordExpression3
	self 
		parse: '1 to: 2 by: 3 do: 4'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordMethod1
	self 
		parse: 'to: a'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordMethod2
	self 
		parse: 'to: a do: b | c |'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordMethod3
	self 
		parse: 'to: a do: b by: c d'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testKeywordMethod4
	self 
		parse: 'to: a do: b by: c | d | e'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testMethod1
	self 
		parse: 'negated ^ 0 - self'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testMethod2
	"Spaces at the beginning of the method."
	self 
		parse: '	  negated ^ 0 - self'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testMethod3
	"Spaces at the end of the method."
	self 
		parse: '	negated ^ 0 - self  '
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral1
	self 
		parse: '0'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral10
	self 
		parse: '10r10'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral11
	self 
		parse: '8r777'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral12
	self 
		parse: '16rAF'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral13
	self 
		parse: '16rCA.FE'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral14
	self 
		parse: '3r-22.2'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 8/13/2011 20:40'!
testNumberLiteral15
	self 
		parse: '0.50s2'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral2
	self 
		parse: '0.1'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral3
	self 
		parse: '123'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral4
	self 
		parse: '123.456'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral5
	self 
		parse: '-0'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral6
	self 
		parse: '-0.1'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral7
	self 
		parse: '-123'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral8
	self 
		parse: '-123'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testNumberLiteral9
	self 
		parse: '-123.456'
		rule: #numberLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma1
	self 
		parse: 'method <foo>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma10
	self 
		parse: 'method <foo: bar>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma11
	self 
		parse: 'method <foo: true>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma12
	self 
		parse: 'method <foo: false>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma13
	self 
		parse: 'method <foo: nil>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma14
	self 
		parse: 'method <foo: ()>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 11/23/2010 13:59'!
testPragma15
	self 
		parse: 'method <foo: #()>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 11/23/2010 13:59'!
testPragma16
	self 
		parse: 'method < + 1 >'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 19:36'!
testPragma17
	self 
		parse: 'method <foo: 1 bar: 2>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 19:58'!
testPragma18
	self 
		parse: 'method <foo: 1 bar: 2  baz: b>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma2
	self 
		parse: 'method <foo> <bar>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma3
	self 
		parse: 'method | a | <foo>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma4
	self 
		parse: 'method <foo> | a |'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma5
	self 
		parse: 'method <foo> | a | <bar>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma6
	self 
		parse: 'method <foo: 1>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma7
	self 
		parse: 'method <foo: 1.2>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma8
	self 
		parse: 'method <foo: ''bar''>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-pragmas' stamp: 'lr 9/27/2009 12:42'!
testPragma9
	self 
		parse: 'method <foo: #''bar''>'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testSequence1
	self 
		parse: '| a | 1 . 2'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testSimpleBlock1
	self 
		parse: '[ ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testSimpleBlock2
	self 
		parse: '[ nil ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testSimpleBlock3
	self 
		parse: '[ :a ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSpecialLiteral1
	self 
		parse: 'true'
		rule: #trueLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSpecialLiteral2
	self 
		parse: 'false'
		rule: #falseLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSpecialLiteral3
	self 
		parse: 'nil'
		rule: #nilLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testStatementBlock1
	self 
		parse: '[ nil ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testStatementBlock2
	self 
		parse: '[ | a | nil ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testStatementBlock3
	self 
		parse: '[ | a b | nil ]'
		rule: #block! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testStatements1
	self 
		parse: '1'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testStatements2
	self 
		parse: '1 . 2'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testStatements3
	self 
		parse: '1 . 2 . 3'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testStatements4
	self 
		parse: '1 . 2 . 3 .'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testStatements5
	self 
		parse: '1 . . 2'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'YuriyTymchuk 3/8/2013 16:10'!
testStatements6
	self 
		parse: '1. 2'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 8/13/2011 20:46'!
testStatements7
	self 
		parse: '. 1'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 8/13/2011 20:46'!
testStatements8
	self 
		parse: '.1'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'JanKurs 10/5/2014 13:51'!
testStatements9
	self 
		parse: ''
		rule: #statements! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testStringLiteral1
	self 
		parse: ''''''
		rule: #stringLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testStringLiteral2
	self 
		parse: '''ab'''
		rule: #stringLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testStringLiteral3
	self 
		parse: '''ab''''cd'''
		rule: #stringLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSymbolLiteral1
	self 
		parse: '#foo'
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSymbolLiteral2
	self 
		parse: '#+'
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSymbolLiteral3
	self 
		parse: '#key:'
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSymbolLiteral4
	self 
		parse: '#key:value:'
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 9/27/2009 12:42'!
testSymbolLiteral5
	self 
		parse: '#''testing-result'''
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 7/11/2011 11:41'!
testSymbolLiteral6
	PPSmalltalkGrammar allowUnderscoreAssignment ifFalse: [
		self 
			parse: '#__gen__binding'
			rule: #symbolLiteral ]! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:26'!
testSymbolLiteral7
	self 
		parse: '# fucker'
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:26'!
testSymbolLiteral8
	self 
		parse: '##fucker'
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing-literals' stamp: 'lr 8/14/2011 12:26'!
testSymbolLiteral9
	self 
		parse: '## fucker'
		rule: #symbolLiteral! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testTemporaries1
	self 
		parse: '| a |'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testTemporaries2
	self 
		parse: '| a b |'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testTemporaries3
	self 
		parse: '| a b c |'
		rule: #sequence! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryExpression1
	self 
		parse: '1 abs'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryExpression2
	self 
		parse: '1 abs negated'
		rule: #expression! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryMethod1
	self 
		parse: 'abs'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryMethod2
	self 
		parse: 'abs | a |'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryMethod3
	self 
		parse: 'abs a'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryMethod4
	self 
		parse: 'abs | a | b'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing-messages' stamp: 'lr 9/27/2009 12:42'!
testUnaryMethod5
	self 
		parse: 'abs | a |'
		rule: #method! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testVariable1
	self 
		parse: 'trueBinding'
		rule: #primary! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testVariable2
	self 
		parse: 'falseBinding'
		rule: #primary! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testVariable3
	self 
		parse: 'nilly'
		rule: #primary! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testVariable4
	self 
		parse: 'selfish'
		rule: #primary! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 9/27/2009 12:42'!
testVariable5
	self 
		parse: 'supernanny'
		rule: #primary! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 7/11/2011 11:41'!
testVariable6
	PPSmalltalkGrammar allowUnderscoreAssignment ifFalse: [
		self 
			parse: 'super_nanny'
			rule: #primary ]! !

!PPSmalltalkGrammarTests methodsFor: 'testing' stamp: 'lr 7/11/2011 11:41'!
testVariable7
	PPSmalltalkGrammar allowUnderscoreAssignment ifFalse: [
		self 
			parse: '__gen_var_123__'
			rule: #primary ]! !

PPSmalltalkGrammarTests subclass: #PPSmalltalkParserTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Tests'!

!PPSmalltalkParserTests methodsFor: 'private' stamp: 'TudorGirba 11/1/2013 23:11'!
assert: aNode format: aString
	aNode isCollection
		ifFalse: [ ^ self assert: (Array with: aNode) format: (Array with: aString) ].
	self assert: aNode size equals: aString size.
	aNode with: aString do: [ :node :string | self assert: (RBConfigurableFormatter format: node) equals: string ]! !

!PPSmalltalkParserTests methodsFor: 'accessing' stamp: 'lr 12/7/2009 09:01'!
parserClass
	^ PPSmalltalkParser! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'Nicolasanquetil 5/3/2013 15:17'!
testArgumentsBlock1
	super testArgumentsBlock1.
	self assert: result isBlock.
	self assert: result arguments size equals: 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name equals: 'a'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'Nicolasanquetil 5/3/2013 15:02'!
testArgumentsBlock2
	super testArgumentsBlock2.
	self assert: result isBlock.
	self assert: result arguments size equals: 2.
	self assert: result arguments first isVariable.
	self assert: result arguments first name equals: 'a'.
	self assert: result arguments second isVariable.
	self assert: result arguments second name equals: 'b'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'Nicolasanquetil 5/3/2013 15:11'!
testArgumentsBlock3
	super testArgumentsBlock3.
	self assert: result isBlock.
	self assert: result arguments size equals: 3.
	self assert: result arguments first isVariable.
	self assert: result arguments first name equals: 'a'.
	self assert: result arguments second isVariable.
	self assert: result arguments second name equals: 'b'.
	self assert: result arguments third isVariable.
	self assert: result arguments third name equals: 'c'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'lr 3/1/2010 10:13'!
testArray1
	super testArray1.
	self assert: result isArray.
	self assert: result statements isEmpty.
	self assert: result periods isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:18'!
testArray2
	super testArray2.
	self assert: result isArray.
	self assert: result periods isEmpty.
	self assert: result statements size equals: 1.
	self assert: result statements first isMessage.
	self assert: result statements first selector equals: #foo! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:03'!
testArray3
	super testArray3.
	self assert: result isArray.
	self assert: result periods size equals: 1.
	self assert: result statements size equals: 2.
	self assert: result statements first isMessage.
	self assert: result statements first selector equals: #foo.
	self assert: result statements last isMessage.
	self assert: result statements last selector equals: #bar! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:11'!
testArray4
	super testArray4.
	self assert: result isArray.
	self assert: result periods size equals: 2.
	self assert: result statements size equals: 2.
	self assert: result statements first isMessage.
	self assert: result statements first selector equals: #foo.
	self assert: result statements last isMessage.
	self assert: result statements last selector equals: #bar! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:14'!
testArrayLiteral1
	super testArrayLiteral1.
	self assert: result isLiteralNode.
	self assert: result value equals: #()! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:14'!
testArrayLiteral10
	super testArrayLiteral10.
	self assert: result isLiteralNode.
	self assert: result value equals: #(#(1 2) #(1 2 3))! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:14'!
testArrayLiteral11
	super testArrayLiteral11.
	self assert: result isLiteralNode.
	self assert: result value size equals: 2.
	self assert: (result value first isKindOf: ByteArray).
	self assert: result value first size equals: 2.
	self assert: (result value last isKindOf: ByteArray).
	self assert: result value last size equals: 3! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:14'!
testArrayLiteral2
	super testArrayLiteral2.
	self assert: result isLiteralNode.
	self assert: result value equals: #(1)! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:14'!
testArrayLiteral3
	super testArrayLiteral3.
	self assert: result isLiteralNode.
	self assert: result value equals: #(1 2)! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:15'!
testArrayLiteral4
	super testArrayLiteral4.
	self assert: result isLiteralNode.
	self assert: result value equals: #(true false nil)! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:15'!
testArrayLiteral5
	super testArrayLiteral5.
	self assert: result isLiteralNode.
	self assert: result value equals: #($a)! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:15'!
testArrayLiteral6
	super testArrayLiteral6.
	self assert: result isLiteralNode.
	self assert: result value equals: #(1.2)! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:15'!
testArrayLiteral7
	super testArrayLiteral7.
	self assert: result isLiteralNode.
	self assert: result value equals: #(#size #at: #at:put: #==).
	result value do: [ :each | self assert: each isSymbol ]! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:15'!
testArrayLiteral8
	super testArrayLiteral8.
	self assert: result isLiteralNode.
	self assert: result value equals: #('baz').
	self assert: result value first isString.
	self assert: result value first isSymbol not! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:15'!
testArrayLiteral9
	super testArrayLiteral9.
	self assert: result isLiteralNode.
	self assert: result value equals: #(#(1) 2)! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:15'!
testAssignment1
	super testAssignment1.
	self assert: result isLiteralNode.
	self assert: result value equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:15'!
testAssignment2
	super testAssignment2.
	self assert: result isAssignment.
	self assert: result variable isVariable.
	self assert: result variable name equals: 'a'.
	self assert: result value isLiteralNode.
	self assert: result value value equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:15'!
testAssignment3
	super testAssignment3.
	self assert: result isAssignment.
	self assert: result variable isVariable.
	self assert: result variable name equals: 'a'.
	self assert: result value isAssignment.
	self assert: result value variable isVariable.
	self assert: result value variable name equals: 'b'.
	self assert: result value value isLiteralNode.
	self assert: result value value value equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:15'!
testAssignment4
	super testAssignment4.
	PPSmalltalkGrammar allowUnderscoreAssignment
		ifFalse: [ ^ self ].
	self assert: result isAssignment.
	self assert: result variable isVariable.
	self assert: result variable name equals: 'a'.
	self assert: result value isLiteralNode.
	self assert: result value value equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:15'!
testAssignment5
	super testAssignment5.
	PPSmalltalkGrammar allowUnderscoreAssignment
		ifFalse: [ ^ self ].
	self assert: result isAssignment.
	self assert: result variable isVariable.
	self assert: result variable name equals: 'a'.
	self assert: result value isAssignment.
	self assert: result value variable isVariable.
	self assert: result value variable name equals: 'b'.
	self assert: result value value isLiteralNode.
	self assert: result value value value equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:16'!
testAssignment6
	super testAssignment6.
	self assert: result isAssignment.
	self assert: result variable isVariable.
	self assert: result variable name equals: 'a'.
	self assert: result value isAssignment.
	self assert: result value variable isVariable.
	self assert: result value variable name equals: 'b'.
	self assert: result value value isVariable.
	self assert: result value value name equals: 'c'! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'TudorGirba 11/1/2013 23:15'!
testBinaryExpression1
	super testBinaryExpression1.
	self assert: result isMessage.
	self assert: result receiver isLiteralNode.
	self assert: result receiver value equals: 1.
	self assert: result arguments size equals: 1.
	self assert: result arguments first isLiteralNode.
	self assert: result arguments first value equals: 2! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'TudorGirba 11/1/2013 23:15'!
testBinaryExpression2
	super testBinaryExpression2.
	self assert: result isMessage.
	self assert: result receiver isMessage.
	self assert: result receiver receiver isLiteralNode.
	self assert: result receiver receiver value equals: 1.
	self assert: result receiver arguments size equals: 1.
	self assert: result receiver arguments first isLiteralNode.
	self assert: result receiver arguments first value equals: 2.
	self assert: result arguments size equals: 1.
	self assert: result arguments first isLiteralNode.
	self assert: result arguments first value equals: 3! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 17:41'!
testBinaryExpression3
	super testBinaryExpression3.
	self assert: result isMessage.
	self assert: result receiver isLiteralNode.
	self assert: result receiver value equals: 1.
	self assert: result selector equals: #//.
	self assert: result keywordsPositions equals: #(3) asIntegerArray.
	self assert: result arguments size equals: 1.
	self assert: result arguments first isLiteralNode.
	self assert: result arguments first value equals: 2! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 17:41'!
testBinaryExpression4
	super testBinaryExpression4.
	self assert: result isMessage.
	self assert: result receiver isLiteralNode.
	self assert: result receiver value equals: 1.
	self assert: result selector equals: #--.
	self assert: result keywordsPositions equals: #(3) asIntegerArray.
	self assert: result arguments size equals: 1.
	self assert: result arguments first isLiteralNode.
	self assert: result arguments first value equals: 2! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 17:41'!
testBinaryExpression5
	super testBinaryExpression5.
	self assert: result isMessage.
	self assert: result receiver isLiteralNode.
	self assert: result receiver value equals: 1.
	self assert: result selector equals: #==>.
	self assert: result keywordsPositions equals: #(3) asIntegerArray.
	self assert: result arguments size equals: 1.
	self assert: result arguments first isLiteralNode.
	self assert: result arguments first value equals: 2! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 17:42'!
testBinaryMethod1
	super testBinaryMethod1.
	self assert: result isMethod.
	self assert: result selector equals: #+.
	self assert: result keywordsPositions equals: #(1) asIntegerArray.
	self assert: result arguments size equals: 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name equals: 'a'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 17:55'!
testBinaryMethod2
	super testBinaryMethod2.
	self assert: result isMethod.
	self assert: result selector equals: #+.
	self assert: result keywordsPositions equals: #(1) asIntegerArray.
	self assert: result arguments size equals: 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name equals: 'a'.
	self assert: result body temporaries size equals: 1.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 17:55'!
testBinaryMethod3
	super testBinaryMethod3.
	self assert: result isMethod.
	self assert: result selector equals: #+.
	self assert: result keywordsPositions equals: #(1) asIntegerArray.	
	self assert: result arguments size equals: 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name equals: 'a'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 17:57'!
testBinaryMethod4
	super testBinaryMethod4.
	self assert: result isMethod.
	self assert: result selector equals: #+.
	self assert: result keywordsPositions equals: #(1) asIntegerArray.	
	self assert: result arguments size equals: 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name equals: 'a'.
	self assert: result body temporaries size equals: 1.
	self assert: result body statements size equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 17:57'!
testBinaryMethod5
	super testBinaryMethod5.
	self assert: result isMethod.
	self assert: result selector equals: #--.
	self assert: result keywordsPositions equals: #(1) asIntegerArray.	
	self assert: result arguments size equals: 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name equals: 'a'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'JanKurs 10/7/2014 17:51'!
testBlock1
	super testBlock1.
	self assert: result isBlock.
	self assert: result arguments size equals: 0.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:16'!
testByteLiteral1
	super testByteLiteral1.
	self assert: result isLiteralNode.
	self assert: (result value isKindOf: ByteArray).
	self assert: result value isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:16'!
testByteLiteral2
	super testByteLiteral2.
	self assert: result isLiteralNode.
	self assert: (result value isKindOf: ByteArray).
	self assert: result value size equals: 1.
	self assert: result value first equals: 0! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:16'!
testByteLiteral3
	super testByteLiteral3.
	self assert: result isLiteralNode.
	self assert: (result value isKindOf: ByteArray).
	self assert: result value size equals: 1.
	self assert: result value first equals: 255! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:16'!
testByteLiteral4
	super testByteLiteral4.
	self assert: result isLiteralNode.
	self assert: (result value isKindOf: ByteArray).
	self assert: result value size equals: 2.
	self assert: result value first equals: 1.
	self assert: result value last equals: 2! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:16'!
testByteLiteral5
	super testByteLiteral5.
	self assert: result isLiteralNode.
	self assert: (result value isKindOf: ByteArray).
	self assert: result value size equals: 3.
	self assert: result value first equals: 10.
	self assert: result value second equals: 63.
	self assert: result value last equals: 255! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 17:58'!
testCascadeExpression1
	super testCascadeExpression1.
	self assert: result isCascade.
	self assert: result receiver isLiteralNode.
	self assert: result messages size equals: 2.
	self assert: result messages first receiver equals: result receiver.
	self assert: result messages first selector equals: #abs.
	self assert: result messages first keywordsPositions equals: #(3) asIntegerArray.
	self assert: result messages second receiver equals: result receiver.
	self assert: result messages second selector equals: #negated.
	self assert: result messages second keywordsPositions equals: #(8) asIntegerArray! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 17:58'!
testCascadeExpression2
	super testCascadeExpression2.
	self assert: result isCascade.
	self assert: result receiver isMessage.
	self assert: result receiver receiver isLiteralNode.
	self assert: result receiver receiver value equals: 1.
	self assert: result receiver selector equals: #abs.
	self assert: result receiver keywordsPositions equals: #(3) asIntegerArray.
	self assert: result messages size equals: 3.
	self assert: result messages first receiver equals: result receiver.
	self assert: result messages first selector equals: #negated.
	self assert: result messages first keywordsPositions equals: #(7) asIntegerArray.
	self assert: result messages second receiver equals: result receiver.
	self assert: result messages second selector equals: #raisedTo:.
	self assert: result messages second keywordsPositions equals: #(16) asIntegerArray.
	self assert: result messages third receiver equals: result receiver.
	self assert: result messages third selector equals: #negated.
	self assert: result messages third keywordsPositions equals: #(30) asIntegerArray! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 18:02'!
testCascadeExpression3
	super testCascadeExpression3.
	self assert: result isCascade.
	self assert: result receiver isLiteralNode.
	self assert: result receiver value equals: 1.
	self assert: result messages size equals: 2.
	self assert: result messages first receiver equals: result receiver.
	self assert: result messages first selector equals: #+.
	self assert: result messages first keywordsPositions equals: #(3) asIntegerArray.				
	self assert: result messages first arguments size equals: 1.
	self assert: result messages second receiver equals: result receiver.
	self assert: result messages second selector equals: #-.
	self assert: result messages second keywordsPositions equals: #(8) asIntegerArray.				
	self assert: result messages second arguments size equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:16'!
testCharLiteral1
	super testCharLiteral1.
	self assert: result isLiteralNode.
	self assert: result value equals: $a! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:16'!
testCharLiteral2
	super testCharLiteral2.
	self assert: result isLiteralNode.
	self assert: result value equals: Character space! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:16'!
testCharLiteral3
	super testCharLiteral3.
	self assert: result isLiteralNode.
	self assert: result value equals: $$! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:20'!
testComment1
	super testComment1.
	self assert: result isMessage.
	self assert: result receiver isValue.
	self assert: result selector equals: #+.
	self assert: result arguments first isValue! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:06'!
testComment2
	super testComment2.
	self assert: result isMessage.
	self assert: result receiver isValue.
	self assert: result selector equals: #+.
	self assert: result arguments first isValue! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:14'!
testComment3
	super testComment3.
	self assert: result isMessage.
	self assert: result receiver isValue.
	self assert: result selector equals: #+.
	self assert: result arguments first isValue! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:20'!
testComment4
	super testComment4.
	self assert: result isMessage.
	self assert: result receiver isValue.
	self assert: result selector equals: #+.
	self assert: result arguments first isValue! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:06'!
testComment5
	super testComment5.
	self assert: result isMessage.
	self assert: result receiver isValue.
	self assert: result selector equals: #+.
	self assert: result arguments first isValue! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'Nicolasanquetil 5/3/2013 15:14'!
testComplexBlock1
	super testComplexBlock1.
	self assert: result isBlock.
	self assert: result arguments size equals: 1.
	self assert: result body temporaries size equals: 1.
	self assert: result body statements size equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'Nicolasanquetil 5/3/2013 14:58'!
testComplexBlock2
	super testComplexBlock2.
	self assert: result isBlock.
	self assert: result arguments size equals: 1.
	self assert: result body temporaries size equals: 1.
	self assert: result body statements size equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 18:03'!
testKeywordExpression1
	super testKeywordExpression1.
	self assert: result isMessage.
	self assert: result receiver isLiteralNode.
	self assert: result receiver value equals: 1.
	self assert: result selector equals: #to:.
	self assert: result keywordsPositions equals: #(3) asIntegerArray.
	self assert: result arguments size equals: 1.
	self assert: result arguments first isLiteralNode.
	self assert: result arguments first value equals: 2! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 18:03'!
testKeywordExpression2
	super testKeywordExpression2.
	self assert: result isMessage.
	self assert: result receiver isLiteralNode.
	self assert: result selector equals: #to:by:.
	self assert: result keywordsPositions equals: #(3 9) asIntegerArray.
	self assert: result arguments size equals: 2.
	self assert: result arguments first isLiteralNode.
	self assert: result arguments first value equals: 2.
	self assert: result arguments second isLiteralNode.
	self assert: result arguments second value equals: 3! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 18:03'!
testKeywordExpression3
	super testKeywordExpression3.
	self assert: result isMessage.
	self assert: result receiver isLiteralNode.
	self assert: result selector equals: #to:by:do:.
	self assert: result keywordsPositions equals: #(3 9 15) asIntegerArray.
	self assert: result arguments size equals: 3.
	self assert: result arguments first isLiteralNode.
	self assert: result arguments first value equals: 2.
	self assert: result arguments second isLiteralNode.
	self assert: result arguments second value equals: 3.
	self assert: result arguments third isLiteralNode.
	self assert: result arguments third value equals: 4! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 18:03'!
testKeywordMethod1
	super testKeywordMethod1.
	self assert: result isMethod.
	self assert: result selector equals: #to:.
	self assert: result keywordsPositions equals: #(1) asIntegerArray.		
	self assert: result arguments size equals: 1.
	self assert: result arguments first isVariable.
	self assert: result arguments first name equals: 'a'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 18:03'!
testKeywordMethod2
	super testKeywordMethod2.
	self assert: result isMethod.
	self assert: result selector equals: #to:do:.
	self assert: result keywordsPositions equals: #(1 7) asIntegerArray.		
	self assert: result arguments size equals: 2.
	self assert: result arguments first isVariable.
	self assert: result arguments first name equals: 'a'.
	self assert: result arguments second isVariable.
	self assert: result arguments second name equals: 'b'.
	self assert: result body temporaries size equals: 1.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 18:04'!
testKeywordMethod3
	super testKeywordMethod3.
	self assert: result isMethod.
	self assert: result selector equals: #to:do:by:.
	self assert: result keywordsPositions equals: #(1 7 13) asIntegerArray.			
	self assert: result arguments size equals: 3.
	self assert: result arguments first isVariable.
	self assert: result arguments first name equals: 'a'.
	self assert: result arguments second isVariable.
	self assert: result arguments second name equals: 'b'.
	self assert: result arguments third isVariable.
	self assert: result arguments third name equals: 'c'.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 18:04'!
testKeywordMethod4
	super testKeywordMethod4.
	self assert: result isMethod.
	self assert: result selector equals: #to:do:by:.
	self assert: result keywordsPositions equals: #(1 7 13) asIntegerArray.			
	self assert: result arguments size equals: 3.
	self assert: result arguments first isVariable.
	self assert: result arguments first name equals: 'a'.
	self assert: result arguments second isVariable.
	self assert: result arguments second name equals: 'b'.
	self assert: result arguments third isVariable.
	self assert: result arguments third name equals: 'c'.
	self assert: result body temporaries size equals: 1.
	self assert: result body statements size equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:16'!
testMethod1
	super testMethod1.
	self assert: result isMethod.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size equals: 1.
	self assert: result body statements first isReturn.
	self assert: result body statements first value isMessage.
	self assert: result body statements first value receiver isLiteralNode.
	self assert: result body statements first value selector equals: #-.
	self assert: result body statements first value arguments size equals: 1.
	self assert: result body statements first value arguments first isVariable! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:17'!
testMethod2
	super testMethod2.
	self assert: result isMethod.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size equals: 1.
	self assert: result body statements first isReturn.
	self assert: result body statements first value isMessage.
	self assert: result body statements first value receiver isLiteralNode.
	self assert: result body statements first value selector equals: #-.
	self assert: result body statements first value arguments size equals: 1.
	self assert: result body statements first value arguments first isVariable! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:17'!
testMethod3
	super testMethod3.
	self assert: result isMethod.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size equals: 1.
	self assert: result body statements first isReturn.
	self assert: result body statements first value isMessage.
	self assert: result body statements first value receiver isLiteralNode.
	self assert: result body statements first value selector equals: #-.
	self assert: result body statements first value arguments size equals: 1.
	self assert: result body statements first value arguments first isVariable! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:17'!
testNumberLiteral1
	super testNumberLiteral1.
	self assert: result isLiteralNode.
	self assert: result value equals: 0.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:17'!
testNumberLiteral10
	super testNumberLiteral10.
	self assert: result isLiteralNode.
	self assert: result value equals: 10.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:17'!
testNumberLiteral11
	super testNumberLiteral11.
	self assert: result isLiteralNode.
	self assert: result value equals: 511.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:17'!
testNumberLiteral12
	super testNumberLiteral12.
	self assert: result isLiteralNode.
	self assert: result value equals: 175.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:17'!
testNumberLiteral13
	super testNumberLiteral13.
	self assert: result isLiteralNode.
	self assert: result value equals: 202.9921875.
	self assert: result value isFloat! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:17'!
testNumberLiteral14
	super testNumberLiteral14.
	self assert: result isLiteralNode.
	self assert: result value floor equals: -9.
	self assert: result value isFloat! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:17'!
testNumberLiteral15
	super testNumberLiteral15.
	self assert: result isLiteralNode.
	self assert: result value equals: 1 / 2! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:17'!
testNumberLiteral2
	super testNumberLiteral2.
	self assert: result isLiteralNode.
	self assert: result value equals: 0.1.
	self assert: result value isFloat! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:17'!
testNumberLiteral3
	super testNumberLiteral3.
	self assert: result isLiteralNode.
	self assert: result value equals: 123.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:17'!
testNumberLiteral4
	super testNumberLiteral4.
	self assert: result isLiteralNode.
	self assert: result value equals: 123.456.
	self assert: result value isFloat! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:17'!
testNumberLiteral5
	super testNumberLiteral5.
	self assert: result isLiteralNode.
	self assert: result value equals: 0.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:18'!
testNumberLiteral6
	super testNumberLiteral6.
	self assert: result isLiteralNode.
	self assert: result value equals: -0.1.
	self assert: result value isFloat! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:18'!
testNumberLiteral7
	super testNumberLiteral7.
	self assert: result isLiteralNode.
	self assert: result value equals: -123.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:18'!
testNumberLiteral8
	super testNumberLiteral8.
	self assert: result isLiteralNode.
	self assert: result value equals: -123.
	self assert: result value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:18'!
testNumberLiteral9
	super testNumberLiteral9.
	self assert: result isLiteralNode.
	self assert: result value equals: -123.456.
	self assert: result value isFloat! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:36'!
testPragma1
	super testPragma1.
	self 
		assert: result pragmas
		format: #('<foo>' ).
	self assert: result pragmas first keywordsPositions equals: #(9) asIntegerArray.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:45'!
testPragma10
	super testPragma10.
	self 
		assert: result pragmas
		format: #('<foo: #bar>' ).
	self assert: result pragmas first keywordsPositions equals: #(9) asIntegerArray.		
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:45'!
testPragma11
	super testPragma11.
	self 
		assert: result pragmas
		format: #('<foo: true>' ).
	self assert: result pragmas first keywordsPositions equals: #(9) asIntegerArray.		
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:46'!
testPragma12
	super testPragma12.
	self 
		assert: result pragmas
		format: #('<foo: false>' ).
	self assert: result pragmas first keywordsPositions equals: #(9) asIntegerArray.		
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:47'!
testPragma13
	super testPragma13.
	self 
		assert: result pragmas
		format: #('<foo: nil>' ).
	self assert: result pragmas first keywordsPositions equals: #(9) asIntegerArray.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:47'!
testPragma14
	super testPragma14.
	self 
		assert: result pragmas
		format: #('<foo: #()>' ).
	self assert: result pragmas first keywordsPositions equals: #(9) asIntegerArray.		
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:48'!
testPragma15
	super testPragma15.
	self 
		assert: result pragmas
		format: #('<foo: #()>' ).
	self assert: result pragmas first keywordsPositions equals: #(9) asIntegerArray.		
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:48'!
testPragma16
	super testPragma16.
	self 
		assert: result pragmas
		format: #('< + 1>' ).
	self assert: result pragmas first keywordsPositions equals: #(10) asIntegerArray.		
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 19:38'!
testPragma17
	super testPragma17.
	self 
		assert: result pragmas
		format: #('<foo: 1 bar: 2>' ).
	self assert: result pragmas first keywordsPositions equals: #(9 16) asIntegerArray.		
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 20:00'!
testPragma18
	super testPragma18.
	self 
		assert: result pragmas
		format: #('<foo: 1 bar: 2 baz: #b>' ).
	self assert: result pragmas first keywordsPositions equals: #(9 16 24) asIntegerArray.		
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:38'!
testPragma2
	super testPragma2.
	self 
		assert: result pragmas
		format: #('<foo>' '<bar>' ).
	self assert: result pragmas first keywordsPositions equals: #(9) asIntegerArray.
	self assert: result pragmas second keywordsPositions equals: #(15) asIntegerArray.		
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:40'!
testPragma3
	super testPragma3.
	self assert: result pragmas format: #('<foo>').
	self assert: result pragmas first keywordsPositions equals: #(15) asIntegerArray.
	self assert: result body temporaries size equals: 1.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:40'!
testPragma4
	super testPragma4.
	self assert: result pragmas format: #('<foo>').
	self assert: result pragmas first keywordsPositions equals: #(9) asIntegerArray.	
	self assert: result body temporaries size equals: 1.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:41'!
testPragma5
	super testPragma5.
	self assert: result pragmas format: #('<foo>' '<bar>').
	self assert: result pragmas first keywordsPositions equals: #(9) asIntegerArray.
	self assert: result pragmas second keywordsPositions equals: #(21) asIntegerArray.	
	self assert: result body temporaries size equals: 1.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:43'!
testPragma6
	super testPragma6.
	self 
		assert: result pragmas
		format: #('<foo: 1>' ).
	self assert: result pragmas first keywordsPositions equals: #(9) asIntegerArray.		
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:43'!
testPragma7
	super testPragma7.
	self 
		assert: result pragmas
		format: #('<foo: 1.2>' ).
	self assert: result pragmas first keywordsPositions equals: #(9) asIntegerArray.		
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:44'!
testPragma8
	super testPragma8.
	self 
		assert: result pragmas
		format: #('<foo: ''bar''>' ).
	self assert: result pragmas first keywordsPositions equals: #(9) asIntegerArray.		
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-pragmas' stamp: 'BernardoContreras 3/13/2015 18:44'!
testPragma9
	super testPragma9.
	self 
		assert: result pragmas
		format: #('<foo: #bar>' ).
	self assert: result pragmas first keywordsPositions equals: #(9) asIntegerArray.		
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:18'!
testSequence1
	super testSequence1.
	self assert: result isSequence.
	self assert: result temporaries size equals: 1.
	self assert: result temporaries first isVariable.
	self assert: result temporaries first name equals: 'a'.
	self assert: result statements size equals: 2.
	self assert: result statements first isLiteralNode.
	self assert: result statements first value equals: 1.
	self assert: result statements second isLiteralNode.
	self assert: result statements second value equals: 2! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'lr 9/27/2009 12:42'!
testSimpleBlock1
	super testSimpleBlock1.
	self assert: result isBlock.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'Nicolasanquetil 5/3/2013 15:06'!
testSimpleBlock2
	super testSimpleBlock2.
	self assert: result isBlock.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'Nicolasanquetil 5/3/2013 15:14'!
testSimpleBlock3
	super testSimpleBlock3.
	self assert: result isBlock.
	self assert: result arguments size equals: 1.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:18'!
testSpecialLiteral1
	super testSpecialLiteral1.
	self assert: result isLiteralNode.
	self assert: result value equals: true! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:18'!
testSpecialLiteral2
	super testSpecialLiteral2.
	self assert: result isLiteralNode.
	self assert: result value equals: false! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:18'!
testSpecialLiteral3
	super testSpecialLiteral3.
	self assert: result isLiteralNode.
	self assert: result value equals: nil! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'Nicolasanquetil 5/3/2013 14:58'!
testStatementBlock1
	super testStatementBlock1.
	self assert: result isBlock.
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'Nicolasanquetil 5/3/2013 15:07'!
testStatementBlock2
	super testStatementBlock2.
	self assert: result isBlock.
	self assert: result arguments isEmpty.
	self assert: result body temporaries size equals: 1.
	self assert: result body statements size equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing-blocks' stamp: 'Nicolasanquetil 5/3/2013 15:15'!
testStatementBlock3
	super testStatementBlock3.
	self assert: result isBlock.
	self assert: result arguments isEmpty.
	self assert: result body temporaries size equals: 2.
	self assert: result body statements size equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:18'!
testStatements1
	super testStatements1.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size equals: 1.
	self assert: result statements first isLiteralNode.
	self assert: result statements first value equals: 1.
	self assert: result statements first value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:18'!
testStatements2
	super testStatements2.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size equals: 2.
	self assert: result statements first isLiteralNode.
	self assert: result statements first value equals: 1.
	self assert: result statements first value isInteger.
	self assert: result statements second isLiteralNode.
	self assert: result statements second value equals: 2.
	self assert: result statements second value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:18'!
testStatements3
	super testStatements3.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size equals: 3.
	self assert: result statements first isLiteralNode.
	self assert: result statements first value equals: 1.
	self assert: result statements first value isInteger.
	self assert: result statements second isLiteralNode.
	self assert: result statements second value equals: 2.
	self assert: result statements second value isInteger.
	self assert: result statements third isLiteralNode.
	self assert: result statements third value equals: 3.
	self assert: result statements third value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:18'!
testStatements4
	super testStatements4.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size equals: 3.
	self assert: result statements first isLiteralNode.
	self assert: result statements first value equals: 1.
	self assert: result statements first value isInteger.
	self assert: result statements second isLiteralNode.
	self assert: result statements second value equals: 2.
	self assert: result statements second value isInteger.
	self assert: result statements third isLiteralNode.
	self assert: result statements third value equals: 3.
	self assert: result statements third value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:18'!
testStatements5
	super testStatements5.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size equals: 2.
	self assert: result statements first isLiteralNode.
	self assert: result statements first value equals: 1.
	self assert: result statements first value isInteger.
	self assert: result statements second isLiteralNode.
	self assert: result statements second value equals: 2.
	self assert: result statements second value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:19'!
testStatements6
	super testStatements6.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size equals: 2.
	self assert: result statements first isLiteralNode.
	self assert: result statements first value equals: 1.
	self assert: result statements first value isInteger.
	self assert: result statements second isLiteralNode.
	self assert: result statements second value equals: 2.
	self assert: result statements second value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:19'!
testStatements7
	super testStatements7.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size equals: 1.
	self assert: result statements first isLiteralNode.
	self assert: result statements first value equals: 1.
	self assert: result statements first value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'TudorGirba 11/1/2013 23:19'!
testStatements8
	super testStatements8.
	self assert: result isSequence.
	self assert: result temporaries isEmpty.
	self assert: result statements size equals: 1.
	self assert: result statements first isLiteralNode.
	self assert: result statements first value equals: 1.
	self assert: result statements first value isInteger! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'JanKurs 10/7/2014 17:53'!
testStatements9
	super testStatements9.
	self assert: result isEmpty.! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:19'!
testStringLiteral1
	super testStringLiteral1.
	self assert: result isLiteralNode.
	self assert: result value equals: ''! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:19'!
testStringLiteral2
	super testStringLiteral2.
	self assert: result isLiteralNode.
	self assert: result value equals: 'ab'! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:19'!
testStringLiteral3
	super testStringLiteral3.
	self assert: result isLiteralNode.
	self assert: result value equals: 'ab''cd'! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:19'!
testSymbolLiteral1
	super testSymbolLiteral1.
	self assert: result isLiteralNode.
	self assert: result value equals: #foo.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:19'!
testSymbolLiteral2
	super testSymbolLiteral2.
	self assert: result isLiteralNode.
	self assert: result value equals: #+.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:19'!
testSymbolLiteral3
	super testSymbolLiteral3.
	self assert: result isLiteralNode.
	self assert: result value equals: #key:.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:19'!
testSymbolLiteral4
	super testSymbolLiteral4.
	self assert: result isLiteralNode.
	self assert: result value equals: #key:value:.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:19'!
testSymbolLiteral5
	super testSymbolLiteral5.
	self assert: result isLiteralNode.
	self assert: result value equals: #'testing-result'.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:19'!
testSymbolLiteral6
	super testSymbolLiteral6.
	PPSmalltalkGrammar allowUnderscoreAssignment
		ifTrue: [ ^ self ].
	self assert: result isLiteralNode.
	self assert: result value equals: #'__gen__binding'.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:19'!
testSymbolLiteral7
	super testSymbolLiteral7.
	self assert: result isLiteralNode.
	self assert: result value equals: #fucker.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:19'!
testSymbolLiteral8
	super testSymbolLiteral8.
	self assert: result isLiteralNode.
	self assert: result value equals: #fucker.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing-literals' stamp: 'TudorGirba 11/1/2013 23:19'!
testSymbolLiteral9
	super testSymbolLiteral9.
	self assert: result isLiteralNode.
	self assert: result value equals: #fucker.
	self assert: result value isSymbol! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:18'!
testTemporaries1
	super testTemporaries1.
	self assert: result isSequence.
	self assert: result temporaries size equals: 1.
	self assert: result temporaries first isVariable.
	self assert: result temporaries first name equals: 'a'.
	self assert: result statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:04'!
testTemporaries2
	super testTemporaries2.
	self assert: result isSequence.
	self assert: result temporaries size equals: 2.
	self assert: result temporaries first isVariable.
	self assert: result temporaries first name equals: 'a'.
	self assert: result temporaries second isVariable.
	self assert: result temporaries second name equals: 'b'.
	self assert: result statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:12'!
testTemporaries3
	super testTemporaries3.
	self assert: result isSequence.
	self assert: result temporaries size equals: 3.
	self assert: result temporaries first isVariable.
	self assert: result temporaries first name equals: 'a'.
	self assert: result temporaries second isVariable.
	self assert: result temporaries second name equals: 'b'.
	self assert: result temporaries third isVariable.
	self assert: result temporaries third name equals: 'c'.
	self assert: result statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 18:04'!
testUnaryExpression1
	super testUnaryExpression1.
	self assert: result isMessage.
	self assert: result receiver isLiteralNode.
	self assert: result selector equals: #abs.
	self assert: result keywordsPositions equals: #(3) asIntegerArray.		
	self assert: result arguments isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 18:04'!
testUnaryExpression2
	super testUnaryExpression2.
	self assert: result isMessage.
	self assert: result receiver isMessage.
	self assert: result receiver receiver isLiteralNode.
	self assert: result receiver receiver value equals: 1.
	self assert: result receiver selector equals: #abs.
	self assert: result receiver keywordsPositions equals: #(3) asIntegerArray.		
	self assert: result receiver arguments isEmpty.
	self assert: result selector equals: #negated.
	self assert: result keywordsPositions equals: #(7) asIntegerArray.		
	self assert: result arguments isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 18:04'!
testUnaryMethod1
	super testUnaryMethod1.
	self assert: result isMethod.
	self assert: result selector equals: #abs.
	self assert: result keywordsPositions equals: #(1) asIntegerArray.		
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 18:04'!
testUnaryMethod2
	super testUnaryMethod2.
	self assert: result isMethod.
	self assert: result selector equals: #abs.
	self assert: result keywordsPositions equals: #(1) asIntegerArray.			
	self assert: result arguments isEmpty.
	self assert: result body temporaries size equals: 1.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 18:04'!
testUnaryMethod3
	super testUnaryMethod3.
	self assert: result isMethod.
	self assert: result selector equals: #abs.
	self assert: result keywordsPositions equals: #(1) asIntegerArray.			
	self assert: result arguments isEmpty.
	self assert: result body temporaries isEmpty.
	self assert: result body statements size equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 18:04'!
testUnaryMethod4
	super testUnaryMethod4.
	self assert: result isMethod.
	self assert: result selector equals: #abs.
	self assert: result keywordsPositions equals: #(1) asIntegerArray.			
	self assert: result arguments isEmpty.
	self assert: result body temporaries size equals: 1.
	self assert: result body statements size equals: 1! !

!PPSmalltalkParserTests methodsFor: 'testing-messages' stamp: 'BernardoContreras 3/13/2015 18:04'!
testUnaryMethod5
	super testUnaryMethod5.
	self assert: result isMethod.
	self assert: result selector equals: #abs.
	self assert: result keywordsPositions equals: #(1) asIntegerArray.		
	self assert: result arguments isEmpty.
	self assert: result body temporaries size equals: 1.
	self assert: result body statements isEmpty! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:06'!
testVariable1
	super testVariable1.
	self assert: result isVariable.
	self assert: result name equals: 'trueBinding'! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:14'!
testVariable2
	super testVariable2.
	self assert: result isVariable.
	self assert: result name equals: 'falseBinding'! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:20'!
testVariable3
	super testVariable3.
	self assert: result isVariable.
	self assert: result name equals: 'nilly'! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:07'!
testVariable4
	super testVariable4.
	self assert: result isVariable.
	self assert: result name equals: 'selfish'! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:15'!
testVariable5
	super testVariable5.
	self assert: result isVariable.
	self assert: result name equals: 'supernanny'! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 14:58'!
testVariable6
	super testVariable6.
	PPSmalltalkGrammar allowUnderscoreAssignment
		ifTrue: [ ^ self ].
	self assert: result isVariable.
	self assert: result name equals: 'super_nanny'! !

!PPSmalltalkParserTests methodsFor: 'testing' stamp: 'Nicolasanquetil 5/3/2013 15:08'!
testVariable7
	super testVariable7.
	PPSmalltalkGrammar allowUnderscoreAssignment
		ifTrue: [ ^ self ].
	self assert: result isVariable.
	self assert: result name equals: '__gen_var_123__'! !

PPToken subclass: #PPSmalltalkToken
	instanceVariableNames: 'comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Core'!

!PPSmalltalkToken methodsFor: 'accessing' stamp: 'TudorGirba 2/28/2015 18:41'!
comments
	^ comments ifNil: [ #() ]! !

!PPSmalltalkToken methodsFor: 'accessing' stamp: 'lr 12/7/2009 09:30'!
comments: anArray
	comments := anArray! !

!PPSmalltalkToken methodsFor: 'compatiblity' stamp: 'lr 2/14/2010 11:58'!
length
	^ self size! !

!RBProgramNode methodsFor: '*petitsmalltalk-accessing' stamp: 'lr 1/29/2010 12:02'!
addComments: aCollectionOfIntervals
	(aCollectionOfIntervals isNil or: [ aCollectionOfIntervals isEmpty ])
		ifFalse: [ self comments: self comments , aCollectionOfIntervals ]! !

PPCompositeParser subclass: #PPSmalltalkGrammar
	instanceVariableNames: 'array arrayItem arrayLiteral arrayLiteralArray assignment assignmentToken binary binaryExpression binaryMessage binaryMethod binaryPragma binaryToken block blockArgument blockArguments blockArgumentsWith blockArgumentsWithout blockBody byteLiteral byteLiteralArray cascadeExpression cascadeMessage char charLiteral charToken expression falseLiteral falseToken identifier identifierToken keyword keywordExpression keywordMessage keywordMethod keywordPragma keywordToken literal message method methodDeclaration methodSequence multiword nilLiteral nilToken number numberLiteral numberToken parens period periodToken pragma pragmaMessage pragmas primary return sequence startExpression startMethod statements string stringLiteral stringToken symbol symbolLiteral symbolLiteralArray temporaries trueLiteral trueToken unary unaryExpression unaryMessage unaryMethod unaryPragma unaryToken variable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Core'!

!PPSmalltalkGrammar commentStamp: 'lr 11/29/2009 09:58' prior: 0!
A parser for Smalltalk methods and expressions.!

!PPSmalltalkGrammar class methodsFor: 'testing' stamp: 'lr 5/1/2012 09:33'!
allowUnderscoreAssignment
	^ (Scanner respondsTo: #allowUnderscoreAsAssignment) and: [ Scanner allowUnderscoreAsAssignment ]! !

!PPSmalltalkGrammar class methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:08'!
parseExpression: aString
	^ self new parseExpression: aString! !

!PPSmalltalkGrammar class methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:09'!
parseExpression: aString onError: aBlock
	^ self new parseExpression: aString onError: aBlock! !

!PPSmalltalkGrammar class methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:09'!
parseMethod: aString
	^ self new parseMethod: aString! !

!PPSmalltalkGrammar class methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:09'!
parseMethod: aString onError: aBlock
	^ self new parseMethod: aString onError: aBlock! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 8/14/2011 11:30'!
array
	^ ${ asParser smalltalkToken , (expression delimitedBy: periodToken) optional , $} asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'TestRunner 10/23/2009 17:39'!
arrayItem
	^ literal / symbolLiteralArray / arrayLiteralArray / byteLiteralArray! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 6/29/2010 14:30'!
arrayLiteral
	^ '#(' asParser smalltalkToken , arrayItem star , $) asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 6/29/2010 14:30'!
arrayLiteralArray
	^ $( asParser smalltalkToken , arrayItem star , $) asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/27/2009 12:42'!
assignment
	^ variable , assignmentToken! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 7/11/2011 11:27'!
assignmentToken
	^ self class allowUnderscoreAssignment
		ifTrue: [ (':=' asParser / '_' asParser) smalltalkToken ]
		ifFalse: [ ':=' asParser smalltalkToken ]! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 8/11/2011 23:29'!
binary
	^ (PPPredicateObjectParser anyOf: '!!%&*+,-/<=>?@\|~') plus! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 9/27/2009 12:42'!
binaryExpression
	^ unaryExpression , binaryMessage star! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 12/6/2009 10:38'!
binaryMessage
	^ (binaryToken , unaryExpression) ==> [ :nodes | 
		Array 
			with: (Array with: nodes first)
			with: (Array with: nodes second) ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'lr 12/6/2009 10:38'!
binaryMethod
	^ (binaryToken , variable) ==> [ :nodes | 
		Array 
			with: (Array with: nodes first)
			with: (Array with: nodes second) ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'TestRunner 10/23/2009 17:34'!
binaryPragma
	^ (binaryToken , arrayItem) ==> [ :nodes | 
		Array 
			with: (Array with: nodes first)
			with: (Array with: nodes second) ]! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
binaryToken
	^ binary smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 6/29/2010 14:30'!
block
	^ $[ asParser smalltalkToken , blockBody , $] asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 6/29/2010 14:30'!
blockArgument
	^ $: asParser smalltalkToken , variable! !

!PPSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 2/4/2010 13:21'!
blockArguments
	^ blockArgumentsWith / blockArgumentsWithout! !

!PPSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 6/29/2010 14:30'!
blockArgumentsWith
	^ blockArgument plus , ($| asParser smalltalkToken / ($] asParser smalltalkToken and ==> [ :node | nil ]))! !

!PPSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 2/4/2010 11:44'!
blockArgumentsWithout
	^ nil asParser ==> [ :nodes | Array with: #() with: nil ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'lr 2/4/2010 11:39'!
blockBody
	^ blockArguments , sequence! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 6/29/2010 14:30'!
byteLiteral
	^ '#[' asParser smalltalkToken , numberLiteral star , $] asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 6/29/2010 14:30'!
byteLiteralArray
	^ $[ asParser smalltalkToken , numberLiteral star , $] asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 9/27/2009 12:42'!
cascadeExpression
	^ keywordExpression , cascadeMessage star! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 6/29/2010 14:30'!
cascadeMessage
	^ $; asParser smalltalkToken , message! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 9/27/2009 12:42'!
char
	^ $$ asParser , #any asParser! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 9/27/2009 12:42'!
charLiteral
	^ charToken! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
charToken
	^ char smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/27/2009 12:42'!
expression
	^ assignment star , cascadeExpression! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 9/27/2009 12:42'!
falseLiteral
	^ falseToken! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
falseToken
	^ ('false' asParser , #word asParser not) smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 7/11/2011 11:32'!
identifier
	^ self class allowUnderscoreAssignment
		ifTrue: [ #letter asParser , #word asParser star ]
		ifFalse: [
			(PPPredicateObjectParser
				on: [ :each | each isLetter or: [ each = $_ ] ]
				message: 'letter expected') ,
			(PPPredicateObjectParser
				on: [ :each | each isAlphaNumeric or: [ each = $_ ] ]
				message: 'letter or digit expected') star ]! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
identifierToken
	^ identifier smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 9/27/2009 12:42'!
keyword
	^ identifier , $: asParser! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 9/27/2009 12:42'!
keywordExpression
	^ binaryExpression , keywordMessage optional! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 12/6/2009 10:38'!
keywordMessage
	^ (keywordToken , binaryExpression) plus ==> [ :nodes | 
		Array 
			with: (nodes collect: [ :each | each first ])
			with: (nodes collect: [ :each | each second ]) ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'lr 12/6/2009 10:38'!
keywordMethod
	^ (keywordToken , variable) plus ==> [ :nodes | 
		Array 
			with: (nodes collect: [ :each | each first ])
			with: (nodes collect: [ :each | each second ]) ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'TestRunner 10/23/2009 17:35'!
keywordPragma
	^ (keywordToken , arrayItem) plus ==> [ :nodes | 
		Array 
			with: (nodes collect: [ :each | each first ])
			with: (nodes collect: [ :each | each second ]) ]! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
keywordToken
	^ keyword smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 5/3/2010 21:46'!
literal
	^ numberLiteral / stringLiteral / charLiteral / arrayLiteral / byteLiteral / symbolLiteral / nilLiteral / trueLiteral / falseLiteral! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/27/2009 12:42'!
message
	^ keywordMessage / binaryMessage / unaryMessage! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/27/2009 12:42'!
method
	^ methodDeclaration , methodSequence! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/27/2009 12:42'!
methodDeclaration
	^ keywordMethod / unaryMethod / binaryMethod! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 8/14/2011 11:23'!
methodSequence
	^ periodToken star , pragmas , periodToken star , temporaries , periodToken star , pragmas , periodToken star , statements! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 9/27/2009 12:42'!
multiword
	^ keyword plus! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 9/27/2009 12:42'!
nilLiteral
	^ nilToken! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
nilToken
	^ ('nil' asParser , #word asParser not) smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'JanKurs 8/19/2014 14:16'!
number
	^ ($- asParser optional , #digit asParser) and , [ :context | 
		[ (NumberParser on: context stream) nextNumber ] 
			on: Error
			do: [ :err | PPFailure message: err messageText at: context position ] ] 
				asParser! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 9/27/2009 12:42'!
numberLiteral
	^ numberToken! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
numberToken
	^ number smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 6/29/2010 14:30'!
parens
	^ $( asParser smalltalkToken , expression , $) asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'parsing' stamp: 'lr 2/19/2010 08:00'!
parseExpression: aString 
	^ self parseExpression: aString onError: [ :msg :pos | self error: msg ]! !

!PPSmalltalkGrammar methodsFor: 'parsing' stamp: 'lr 2/19/2010 08:04'!
parseExpression: aString onError: aBlock
	^ startExpression parse: aString onError: aBlock! !

!PPSmalltalkGrammar methodsFor: 'parsing' stamp: 'lr 2/19/2010 08:01'!
parseMethod: aString 
	^ self parseMethod: aString onError: [ :msg :pos | self error: msg ]! !

!PPSmalltalkGrammar methodsFor: 'parsing' stamp: 'lr 2/19/2010 08:04'!
parseMethod: aString onError: aBlock
	^ startMethod parse: aString onError: aBlock! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 8/13/2011 20:51'!
period
	^ $. asParser! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 8/13/2011 20:52'!
periodToken
	^ period smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 6/29/2010 14:30'!
pragma
	^ $< asParser smalltalkToken , pragmaMessage , $> asParser smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'lr 9/27/2009 12:42'!
pragmaMessage
	^ keywordPragma / unaryPragma / binaryPragma! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/27/2009 12:42'!
pragmas
	^ pragma star! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 5/3/2010 21:39'!
primary
	^ literal / variable / block / parens / array! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 6/29/2010 14:30'!
return
	^ $^ asParser smalltalkToken , expression! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 8/14/2011 11:13'!
sequence
	^ temporaries , periodToken star , statements! !

!PPSmalltalkGrammar methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:05'!
start
	"Default start production."

	^ startMethod! !

!PPSmalltalkGrammar methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:03'!
startExpression
	"Start production for the expression."

	^ sequence end! !

!PPSmalltalkGrammar methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:03'!
startMethod
	"Start production for the method."

	^ method end! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/9/2012 15:40'!
statements
	^ 	(expression wrapped , ((periodToken plus , statements ==> [ :nodes | nodes first , nodes last ])
								/ periodToken star)
			==> [ :nodes | (Array with: nodes first) , (nodes last) ])
	/	(return , periodToken star
			==> [ :nodes | (Array with: nodes first) , (nodes last) ])
	/	(periodToken star)! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 1/8/2010 15:38'!
string
	^ $' asParser , ('''''' asParser / $' asParser negate) star , $' asParser! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 9/27/2009 12:42'!
stringLiteral
	^ stringToken! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
stringToken
	^ string smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 9/27/2009 12:42'!
symbol
	^ unary / binary / multiword / string! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 8/14/2011 12:27'!
symbolLiteral
	"This is totally fucked up: The Pharo compiler allows multiple #, arbitrary spaces between the # and the symbol, as well as comments inbetween. And yes, it is used."

	^ $# asParser smalltalkToken plus , symbol smalltalkToken ==> [ :tokens | tokens first copyWith: tokens last ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 6/29/2010 14:30'!
symbolLiteralArray
	^ symbol smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 6/29/2010 14:30'!
temporaries
	^ ($| asParser smalltalkToken , variable star , $| asParser smalltalkToken) optional ==> [ :nodes | nodes ifNil: [ #() ] ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'lr 9/27/2009 12:42'!
trueLiteral
	^ trueToken! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
trueToken
	^ ('true' asParser , #word asParser not) smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'primitives' stamp: 'lr 9/27/2009 12:42'!
unary
	^ identifier , $: asParser not! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 9/27/2009 12:42'!
unaryExpression
	^ primary , unaryMessage star! !

!PPSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'lr 12/6/2009 10:39'!
unaryMessage
	^ unaryToken ==> [ :node | 
		Array 
			with: (Array with: node)
			with: Array new ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'lr 12/6/2009 10:39'!
unaryMethod
	^ identifierToken ==> [ :node | 
		Array 
			with: (Array with: node)
			with: Array new ]! !

!PPSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'TestRunner 10/23/2009 16:35'!
unaryPragma
	^ identifierToken ==> [ :node | 
		Array 
			with: (Array with: node)
			with: (Array new) ]! !

!PPSmalltalkGrammar methodsFor: 'token' stamp: 'lr 6/29/2010 14:30'!
unaryToken
	^ unary smalltalkToken! !

!PPSmalltalkGrammar methodsFor: 'grammar' stamp: 'lr 9/27/2009 12:42'!
variable
	^ identifierToken! !

PPSmalltalkGrammar subclass: #PPSmalltalkParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitSmalltalk-Core'!

!PPSmalltalkParser commentStamp: 'lr 11/29/2009 09:58' prior: 0!
Enhances the Smalltalk grammar with production actions to build parse-tree nodes of the refactoring browser.!

!PPSmalltalkParser methodsFor: 'private' stamp: 'lr 8/14/2011 12:04'!
addStatements: aCollection into: aNode
	aCollection isNil 
		ifTrue: [ ^ aNode ].
	aCollection do: [ :each |
		each class == PPSmalltalkToken
			ifFalse: [ aNode addNode:  each ]
			ifTrue: [
				aNode statements isEmpty
					ifTrue: [ aNode addComments: each comments ]
					ifFalse: [ aNode statements last addComments: each comments ].
				aNode periods: (aNode periods asOrderedCollection
					addLast: each start;
					yourself) ] ].
	^ aNode! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 8/14/2011 11:51'!
array
	^ super array map: [ :openNode :statementNodes :closeNode |
		(self buildArray: statementNodes)
			left: openNode start;
			right: closeNode start;
			yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TestRunner 11/5/2009 11:41'!
arrayLiteral
	^ super arrayLiteral ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: false ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TestRunner 11/5/2009 11:41'!
arrayLiteralArray
	^ super arrayLiteralArray ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: false ]! !

!PPSmalltalkParser methodsFor: 'grammar-messages' stamp: 'lr 12/6/2009 10:39'!
binaryExpression
	^ super binaryExpression map: [ :receiverNode :messageNodes | self build: receiverNode messages: messageNodes ]! !

!PPSmalltalkParser methodsFor: 'token' stamp: 'lr 2/26/2013 01:03'!
binaryToken
	^ super binaryToken ==> [ :token | (RBBinarySelectorToken value: token inputValue start: token start) comments: token comments; yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar-blocks' stamp: 'lr 12/6/2009 10:37'!
block
	^ super block map: [ :leftToken :blockNode :rightToken | blockNode left: leftToken start; right: rightToken start ]! !

!PPSmalltalkParser methodsFor: 'grammar-blocks' stamp: 'lr 9/27/2009 12:42'!
blockArgument
	^ super blockArgument ==> #second! !

!PPSmalltalkParser methodsFor: 'grammar-blocks' stamp: 'AndreHora 2/14/2014 17:01'!
blockBody
	^ super blockBody
		==> [ :nodes | 
			| result |
			result := RBBlockNode arguments: nodes first first body: nodes last.
			nodes first last ifNotNil: [ result bar: nodes first last start ].
			result ]! !

!PPSmalltalkParser methodsFor: 'private' stamp: 'TestRunner 11/5/2009 10:36'!
build: aNode assignment: anArray
	^ anArray isEmpty
		ifTrue: [ aNode ]
		ifFalse: [
			anArray reverse 
				inject: aNode
				into: [ :result :each |
					RBAssignmentNode 
						variable: each first
						value: result
						position: each second start ] ]! !

!PPSmalltalkParser methodsFor: 'private' stamp: 'lr 9/11/2010 10:11'!
build: aNode cascade: anArray 
	| messages semicolons |
	^ (anArray isNil or: [ anArray isEmpty ]) 
		ifTrue: [ aNode ]
		ifFalse: [
			messages := OrderedCollection new: anArray size + 1.
			messages addLast: aNode.
			semicolons := OrderedCollection new.
			anArray do: [ :each | 
				messages addLast: (self 
					build: aNode receiver
					messages: (Array with: each second)).
				semicolons addLast: each first start ].
			RBCascadeNode messages: messages semicolons: semicolons ]! !

!PPSmalltalkParser methodsFor: 'private' stamp: 'BernardoContreras 3/13/2015 20:58'!
build: aNode messages: anArray
	^ (anArray isNil or: [ anArray isEmpty ])
		ifTrue: [ aNode ]
		ifFalse: [ 
			anArray
				inject: aNode
				into: [ :rec :msg | 
					msg isNil
						ifTrue: [ rec ]
						ifFalse: [ 
							RBMessageNode
								receiver: rec
								selector: (self buildSelector: msg first)
								keywordsPositions: (msg first collect: [ :each | each start ])
								arguments: msg second ] ] ]! !

!PPSmalltalkParser methodsFor: 'private' stamp: 'lr 8/14/2011 12:03'!
build: aTempCollection sequence: aStatementCollection
	| result |
	result := self
		addStatements: aStatementCollection
		into: RBSequenceNode new.
	aTempCollection isEmpty ifFalse: [
		result
			leftBar: aTempCollection first start
			temporaries: aTempCollection second
			rightBar: aTempCollection last start ].
	^ result! !

!PPSmalltalkParser methodsFor: 'private' stamp: 'lr 8/14/2011 12:00'!
buildArray: aStatementCollection
	^ self addStatements: aStatementCollection into: RBArrayNode new! !

!PPSmalltalkParser methodsFor: 'private' stamp: 'TudorGirba 3/2/2015 16:51'!
buildMethod: aMethodNode
	self flag: 'check this one thoroughly as it is unclear if the changes preserve 
	the original behavior from before the AST refactoring '.
"	aMethodNode selectorParts 
		do: [ :each | aMethodNode addComments: each comments ].
"	aMethodNode arguments
		do: [ :each | aMethodNode addComments: each comments ].
	aMethodNode pragmas do: [ :aPragma |
		aMethodNode addComments: aPragma comments.
		aMethodNode addComments: aPragma comments.
		aPragma arguments do: [ :each | 
			each isLiteralArray
				ifFalse: [ aMethodNode addComments: each comments ] ].
		aPragma comments: #() ].
	^ aMethodNode! !

!PPSmalltalkParser methodsFor: 'private' stamp: 'BernardoContreras 3/13/2015 20:58'!
buildSelector: anArray
	^ (String streamContents: [ :stream | anArray do: [ :each | stream nextPutAll: each value ] ]) asSymbol! !

!PPSmalltalkParser methodsFor: 'private' stamp: 'lr 8/14/2011 12:25'!
buildString: aString 
	(aString isEmpty or: [ aString first ~= $' or: [ aString last ~= $' ] ])
		ifTrue: [ ^ aString ].
	^ (aString 
		copyFrom: 2
		to: aString size - 1) 
		copyReplaceAll: ''''''
		with: ''''! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TestRunner 11/5/2009 11:41'!
byteLiteral
	^ super byteLiteral ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: true ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TestRunner 11/5/2009 11:41'!
byteLiteralArray
	^ super byteLiteralArray ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: true ]! !

!PPSmalltalkParser methodsFor: 'grammar-messages' stamp: 'lr 12/6/2009 10:40'!
cascadeExpression
	^ super cascadeExpression map: [ :receiverNode :messageNodes | self build: receiverNode cascade: messageNodes ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TudorGirba 3/2/2015 16:38'!
charLiteral
	^ super charLiteral ==> [ :token | 
		(RBLiteralValueNode 
			value: token inputValue second 
			start: token start 
			stop: token stop) comments: token comments; yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 12/6/2009 10:40'!
expression
	^ super expression map: [ :variableNodes :expressionNodes | self build: expressionNodes assignment: variableNodes ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TudorGirba 3/2/2015 16:37'!
falseLiteral
	^ super falseLiteral ==> [ :token | 
		(RBLiteralValueNode 
			value: false 
			start: token start 
			stop: token stop) comments: token comments; yourself ]! !

!PPSmalltalkParser methodsFor: 'token' stamp: 'lr 2/26/2013 01:06'!
identifierToken
	^ super identifierToken ==> [ :token | (RBIdentifierToken value: token inputValue start: token start) comments: token comments; yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar-messages' stamp: 'lr 12/6/2009 10:41'!
keywordExpression
	^ super keywordExpression map: [ :receiveNode :messageNode | self build: receiveNode messages: (Array with: messageNode) ]! !

!PPSmalltalkParser methodsFor: 'token' stamp: 'lr 2/26/2013 01:03'!
keywordToken
	^ super keywordToken ==> [ :token | (RBKeywordToken value: token inputValue start: token start) comments: token comments; yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 8/13/2011 21:09'!
method
	^ super method map: [ :methodNode :bodyNode | 
		methodNode pragmas: bodyNode first.
		methodNode body: bodyNode second.
		self buildMethod: methodNode ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'BernardoContreras 3/13/2015 21:00'!
methodDeclaration
	^ super methodDeclaration
		==> [ :nodes | 
			(RBMethodNode
				selector: (self buildSelector: nodes first)
				keywordsPositions: (nodes first collect: [ :each | each start ])
				arguments: nodes second)
				body: (RBSequenceNode statements: #());
				yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 8/14/2011 11:24'!
methodSequence
	^ super methodSequence map: [ :periodNodes1 :pragmaNodes1 :periodNodes2 :tempNodes :periodNodes3 :pragmaNodes2 :periodNodes4 :statementNodes |
		Array
			with: pragmaNodes1 , pragmaNodes2
			with: (self build: tempNodes sequence: periodNodes1 , periodNodes2 , periodNodes3 , periodNodes4 , statementNodes) ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TudorGirba 3/2/2015 16:38'!
nilLiteral
	^ super nilLiteral ==> [ :token | 
		(RBLiteralValueNode 
			value: nil 
			start: token start 
			stop: token stop) comments: token comments; yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TudorGirba 2/28/2015 18:39'!
numberLiteral
	^ super numberLiteral 
	
	==> [ :token | 
		(RBLiteralValueNode 
			value: (Number readFrom: token inputValue) 
			start: token start 
			stop: token stop 
			source: token inputValue) 
				comments: token comments; yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 12/6/2009 10:42'!
parens
	^ super parens map: [ :openToken :expressionNode :closeToken | expressionNode addParenthesis: (openToken start to: closeToken start) ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'BernardoContreras 3/13/2015 21:02'!
pragma
	^ super pragma
		==> [ :nodes | 
			(RBPragmaNode
				selector: (self buildSelector: nodes second first)
				keywordsPositions: (nodes second first collect: [ :each | each start ])
				arguments: nodes second second)
				addComments: nodes first comments;
				addComments: nodes last comments;
				left: nodes first start;
				right: nodes last start;
				yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 12/6/2009 10:42'!
return
	^ super return map: [ :token :expressionNode | RBReturnNode return: token start value: expressionNode ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'lr 8/14/2011 11:14'!
sequence
	^ super sequence map: [ :tempNodes :periodNodes :statementNodes | self build: tempNodes sequence: periodNodes , statementNodes ]! !

!PPSmalltalkParser methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:07'!
startExpression
	"Make the sequence node has a method node as its parent and that the source is set."

	^ ([ :stream | stream collection ] asParser and , super startExpression) map: [ :source :node | 
		(RBMethodNode selector: #doIt body: node)
			source: source.
		(node statements size = 1 and: [ node temporaries isEmpty ])
			ifTrue: [ node statements first ]
			ifFalse: [ node ] ]! !

!PPSmalltalkParser methodsFor: 'accessing' stamp: 'lr 2/19/2010 08:20'!
startMethod
	"Make sure the method node has the source code properly set."
	
	^ ([ :stream | stream collection ] asParser and , super startMethod)
		map: [ :source :node | node source: source ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TudorGirba 3/2/2015 16:39'!
stringLiteral
	^ super stringLiteral ==> [ :token | (RBLiteralValueNode value: (self buildString: token inputValue) start: token start stop: token stop) comments: token comments; yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TudorGirba 3/2/2015 16:39'!
symbolLiteral
	^ super symbolLiteral ==> [ :tokens | 
		(RBLiteralValueNode value: (self buildString: tokens last inputValue) asSymbol start: tokens first start stop: tokens last stop) comments: tokens last comments; yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TudorGirba 3/2/2015 16:39'!
symbolLiteralArray
	^ super symbolLiteralArray ==> [ :token | 
		(RBLiteralValueNode 
			value: (self buildString: token inputValue) asSymbol 
			start: token start 
			stop: token stop) comments: token comments; yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar-literals' stamp: 'TudorGirba 2/28/2015 18:42'!
trueLiteral
	^ super trueLiteral 
	
	==> [ :token | 
		(RBLiteralValueNode 
			value: true 
			start: token start
			stop: token stop) 
				comments: token comments; yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar-messages' stamp: 'lr 12/6/2009 10:43'!
unaryExpression
	^ super unaryExpression map: [ :receiverNode :messageNodes | self build: receiverNode messages: messageNodes ]! !

!PPSmalltalkParser methodsFor: 'token' stamp: 'lr 2/26/2013 01:03'!
unaryToken
	^ super unaryToken ==> [ :token | (RBIdentifierToken value: token inputValue start: token start) comments: token comments; yourself ]! !

!PPSmalltalkParser methodsFor: 'grammar' stamp: 'TudorGirba 2/28/2015 15:59'!
variable
	^ super variable ==> [ :token | RBVariableNode identifierNamed: token value  at: token start ]! !

PPTokenParser subclass: #PPSmalltalkTokenParser
	instanceVariableNames: ''
	classVariableNames: 'SeparatorPredicate'
	poolDictionaries: ''
	category: 'PetitSmalltalk-Core'!

!PPSmalltalkTokenParser commentStamp: 'JanKurs 11/14/2014 17:03' prior: 0!
A parser that knows how to skip comments and whitespace in Smalltalk and how to instantiate tokens!

!PPSmalltalkTokenParser class methodsFor: 'initialization' stamp: 'lr 9/5/2010 23:42'!
initialize
	SeparatorPredicate := PPCharSetPredicate on: [ :char | char isSeparator ]! !

!PPSmalltalkTokenParser methodsFor: 'private' stamp: 'lr 4/6/2010 20:13'!
defaultTokenClass
	^ PPSmalltalkToken! !

!PPSmalltalkTokenParser methodsFor: 'parsing' stamp: 'JanKurs 8/19/2014 14:07'!
parseComments: anArray on: aPPContext
	| start comments |
	comments := anArray.
	[ [ aPPContext atEnd not and: [ SeparatorPredicate value: aPPContext uncheckedPeek ] ]
		whileTrue: [ aPPContext next ].
	 aPPContext atEnd not and: [ aPPContext uncheckedPeek = $" ] ] whileTrue: [
		aPPContext next.
		start := aPPContext position.
		aPPContext upTo: $".
		comments := comments copyWith: (start to: aPPContext position) ].
	^ comments! !

!PPSmalltalkTokenParser methodsFor: 'parsing' stamp: 'JanKurs 8/19/2014 14:06'!
parseOn: aPPContext
	| memento comments token |
	memento := aPPContext remember.
	comments := self
		parseComments: #()
		on: aPPContext.
	token := super parseOn: aPPContext.
	token isPetitFailure ifTrue: [
		aPPContext restore: memento.
		^ token ].
	comments := self
		parseComments: comments
		on: aPPContext.
	^ token comments: comments! !
PPSmalltalkTokenParser initialize!
